local class = require"engine.class"
local ActorTalents = require "engine.interface.ActorTalents"
local ActorTemporaryEffects = require "engine.interface.ActorTemporaryEffects"
local Birther = require "engine.Birther"
local DamageType = require "engine.DamageType"
local Zone = require "engine.Zone"
local Map = require "engine.Map"
local Actor = require "engine.Actor"
--require "engine.Autolevel"
--require "engine.interface.ActorInventory"
--require "mod.class.interface.ActorLife"
require "engine.interface.ActorProject"
--require "engine.interface.ActorLevel"
--require "engine.interface.ActorStats"
--require "engine.interface.ActorResource"
--require "engine.interface.BloodyDeath"
--require "engine.interface.ActorFOV"
--require "mod.class.interface.ActorPartyQuest"
--require "mod.class.interface.Combat"
--require "mod.class.interface.Archery"
--require "mod.class.interface.ActorInscriptions"
--local Faction = require "engine.Faction"
--local Dialog = require "engine.ui.Dialog"

local DamageType = require "engine.DamageType"
local lastTalent = 1


class:bindHook("ToME:load", function(self, data)
	DamageType:loadDefinition("/data-witchdoctor/new_damage_types.lua")
	ActorTalents:loadDefinition("/data-witchdoctor/talents/talents.lua")	
	Birther:loadDefinition("/data-witchdoctor/birth/classes/wilder.lua")
end)
class:bindHook("Actor:preUseTalent",function(self, data)
	if data.fake == true and self:hasEffect(self.EFF_VIM_CASTING) then
		if lastTalent ~= data.t and data.t.equilibrium and not self:equilibriumChance() then
			self:incVim(-100*(math.sqrt(self:getEquilibrium() - self:getWil()) / 60))
			lastTalent = data.t
		end
	end
end)
class:bindHook("Actor:postUseTalent", function(self, data)
	if data.t and data.t.type[1]:find("^corruption/") and self.knowTalent and self:knowTalent(self.T_TWISTED) and self:isTalentActive(self.T_TWISTED) then
		local tids = {}
		for tid, lev in pairs(self.talents) do
			local t = self:getTalentFromId(tid)
			if t and t.type[1]:find("^wild%-gift/") and not self.talents_cd[tid] and t.mode == "activated" and not t.innate then tids[#tids+1] = t end
		end
		if #tids == 0 then else
			local t = rng.tableRemove(tids)
			self:startTalentCooldown(t)
			self:alterTalentCoolingdown(t,-(self:getTalentCooldown(t)-1))
			game.logSeen(self, "%s talent '%s%s' is disrupted by nature for using vim.", self.name:capitalize(), (t.display_entity and t.display_entity:getDisplayString() or ""), t.name)
		end
		if data.t.vim then
		self:incEquilibrium(-4.5*data.t.vim)
		end
	end
end)
class:bindHook("Combat:attackTargetWith", function(self, data)
	if data.hitted and data.target.knowTalent and data.target:knowTalent(data.target.T_POISONED_KNOWLEDGE) and data.target:getTalentLevel(data.target.T_POISONED_KNOWLEDGE) > 4 then --and data.target:knowTalent(data.target.T_PARALYSING_VENOM) then
		local t = data.target:getTalentFromId(data.target.T_POISONED_KNOWLEDGE)
		--if not t then else
		t.do_poison(data.target ,data.target.T_POISONED_KNOWLEDGE, self)
		--end
	end
end)
class:bindHook("DamageProjector:final", function(self, data)
	local target = game.level.map(data.x, data.y, Map.ACTOR)
	local t = data.src.__projecting_for and data.src.__projecting_for.project_type and (data.src.__projecting_for.project_type.talent_id or data.src.__projecting_for.project_type.talent) and data.src.getTalentFromId and data.src:getTalentFromId(data.src.__projecting_for.project_type.talent or data.src.__projecting_for.project_type.talent_id)
	if not t then else
		if not target.dead and t.is_spell and target.knowTalent and target:knowTalent(target.T_POISONED_KNOWLEDGE) and target:getTalentLevel(target.T_POISONED_KNOWLEDGE) > 2 and target:knowTalent(target.T_MANA_TOXIN) then
			target:triggerTalent(target.T_POISONED_KNOWLEDGE, nil ,data.src)
		end
	end
	if target and target.knowTalent and target:knowTalent(target.T_VIM_SHELL) and target:isTalentActive(target.T_VIM_SHELL)	then
		local t = target:getTalentFromId(target.T_VIM_SHELL)
		local hpdiff = data.dam/target.max_life
		if hpdiff > t.minDam(self, t) and not target:hasEffect(EFF_DAMAGE_SHIELD) then
			target:setEffect(target.EFF_DAMAGE_SHIELD, 5, {power=data.dam+(data.dam/3)})
		end
	end
end)